// 如果没有通过拦截器配置域名的话，可以在这里写上完整的URL(加上域名部分)
const apiList = require("./apiList")
// 此处第二个参数vm，就是我们在页面使用的this，你可以通过vm获取vuex等操作，更多内容详见uView对拦截器的介绍部分：
// https://uviewui.com/js/http.html#%E4%BD%95%E8%B0%93%E8%AF%B7%E6%B1%82%E6%8B%A6%E6%88%AA%EF%BC%9F
const install = (Vue, vm) => {

	const login = (data = {}) => vm.$u.post(apiList.login, data)
	// 系统设置
	const settingGet = (params = {}) => vm.$u.get(apiList.settingGet, params)
	// 购买记录
	const memberRecord = (params = {}) => vm.$u.get(apiList.memberRecord, params)
	// 获取用户信息
	const userGet = (params = {}) => vm.$u.get(apiList.userGet, params)
	// 用户收入
	const userIncome = (params = {}) => vm.$u.get(apiList.userIncome, params)
	// 用户余额
	const userOverage = (params = {}) => vm.$u.get(apiList.userOverage, params)
	// 购买会员
	const userBuy = (data = {}) => vm.$u.post(apiList.userBuy, data)

	// 提现申请
	const withdrawApply = (data = {}) => vm.$u.post(apiList.withdrawApply, data)
	// 提现列表
	const withdrawLists = (params = {}) => vm.$u.get(apiList.withdrawLists, params)
	// 查询订单
	const userQuery = (params = {}) => vm.$u.get(apiList.userQuery, params)
	// 提现列表
	const userShares = (params = {}) => vm.$u.get(apiList.userShares, params)
	// 提现列表
	const userBind = (data = {}) => vm.$u.post(apiList.userBind, data)
	// 用户绑定手机号
	const userBindPhone = (data = {}) => vm.$u.post(apiList.userBindPhone, data)
	// 用户绑定手机号
	const userUpdate = (data = {}) => vm.$u.post(apiList.userUpdate, data)

	//将各个定义的接口名称，统一放进对象挂载到vm.$u.api(因为vm就是this，也即this.$u.api)下
	vm.$u.api = {
		login,
		settingGet,

		memberRecord,

		userGet,
		userIncome,
		userOverage,
		userBuy,
		userQuery,
		userShares,
		userBind,
		userBindPhone,
		userUpdate,

		withdrawApply,
		withdrawLists,
	};
}

export default {
	install
}
